/*
   +----------------------------------------------------------------------+
   | Copyright (c) 2002-2005 J Smith <dark_panda@hushmail.com>            |
   | Crypto++ sources (not included) copyright (c) 1995-2003 Wei Dai      |
   +----------------------------------------------------------------------+
   | Check out COPYING for the exact license.                             |
   +----------------------------------------------------------------------+

$Id: jbasiccipherinfo.h,v 1.5 2005/01/06 18:16:42 jay Exp $
*/

#ifndef __JBASICCIPHERINFO_H__
#define __JBASICCIPHERINFO_H__

#include "jcipher.h"
#include "jstream.h"

template <typename INFO, typename BASE>
class JBasicCipherInfo : public BASE
{
	public:
		unsigned int getValidKeylength(const unsigned int length) const;
		unsigned int getDefaultKeylength() const;
		unsigned int getMaxKeylength() const;
		unsigned int getMinKeylength() const;
		unsigned int getMultKeylength() const;
		string getCipherName() const;
		static string getStaticCipherName();
};

#include "jbasiccipherinfo.cpp"

#endif
